package se.nekotronic.gpsavg;

import java.text.DecimalFormat;

import android.support.v7.app.ActionBarActivity;
import android.content.Context;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.TextView;


public class MainActivity extends ActionBarActivity {
	
	private TextView texten = null;
	private LocationManager location_manager;
	private LocationListener location_listener;
	private final DecimalFormat dec = new DecimalFormat("0.00000000");
	
	public static void print(String nothing) { }

	private double longsum = 0;
	private double latsum = 0;
	private int nr_values = 0;
	
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        // setContentView(R.layout.activity_main);
        texten =  new TextView(this);
        texten.setText("Waiting for first GPS location...");
        setContentView(texten);
        
        location_manager = (LocationManager) this.getSystemService(Context.LOCATION_SERVICE);
        location_listener = new LocationListener() {
            @Override
            public void onLocationChanged(Location location) {
                double longitude = location.getLongitude();
                double latitude = location.getLatitude();
                double accuracy = location.getAccuracy();
                double altitude= location.getAltitude();
                
                longsum += longitude;
                latsum += latitude;
                ++nr_values;
                
                double longavg = longsum / nr_values;
                double latavg = latsum / nr_values;
                
                texten.setText("Avgerage:\n" +
                	  "Long: " + dec.format(longavg) + "\n" +
                      "Lat: " + dec.format(latavg) + "\n" +
                      "\n" +
                      "Based on " + nr_values + " measurements.\n" +
                      "\n" +
                      "Latest position:\n" +
                      "Long: " + dec.format(longitude) + "\n" +
                      "Lat: " + dec.format(latitude) + "\n" +
                      "Accuracy: " + dec.format(accuracy) + "\n" +
                      "Altitude: " + dec.format(altitude));

                print("New location: Long " + dec.format(longitude) +
                      ", lat " + dec.format(latitude) +
                      ", accuracy " + dec.format(accuracy) +
                      ", alt " + dec.format(altitude));

                texten.invalidate();
            }
            
            /*
            @Override
            public void onProviderDisabled(String provider) {
                 print("Location provider has been disabled.");
            }

            @Override
            public void onProviderEnabled(String provider) {
                 print("Good news! Location provider has been enabled.");
            }

            @Override
            public void onStatusChanged(String provider, int status,
                    Bundle extras) {
                if (status == LocationProvider.OUT_OF_SERVICE)
                    print("GPS status changed to OUT_OF_SERVICE.");
                else if (status == LocationProvider.TEMPORARILY_UNAVAILABLE)
                    print("GPS status changed to TEMPORARILY_UNAVAILABLE.");
                else if (status == LocationProvider.AVAILABLE)
                    print("Good news! GPS status changed to AVAILABLE.");
            }
*/

			@Override
			public void onProviderDisabled(String provider) {
				
				
			}

			@Override
			public void onProviderEnabled(String provider) {
				
				
			}

			@Override
			public void onStatusChanged(String provider, int status, Bundle extras) {
				
				
			}
	
        };
    } // onCreate

    @Override
    protected void onResume() {
        super.onResume();
        print("onResume");
        try {
            // Register the listener with the Location Manager to receive
            // location updates
            location_manager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0, location_listener);
        }
        catch (Exception e) {
            print("Couldn't use the GPS: " + e + ", " + e.getMessage());
        }
    } // onResume
    
    @Override
    protected void onPause() {
        super.onPause();
        print("onPause");
        location_manager.removeUpdates(location_listener);
    } // onPause
    
} // MainActivity
